unit uwin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ImgList, Buttons, Mask;

type
  Twin = class(TForm)
    Notes: TPaintBox;
    bLoad: TButton;
    ImageList1: TImageList;
    OpenD: TOpenDialog;
    MaskEdit: TEdit;
    bLeft: TButton;
    bRight: TButton;
    Label1: TLabel;
    bSave: TButton;
    SaveDialog1: TSaveDialog;
    procedure NotesPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bLoadClick(Sender: TObject);
    procedure bRightClick(Sender: TObject);
    procedure bLeftClick(Sender: TObject);
    procedure bSaveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
 X_BEGIN = 10; // Start notove osnovy
 Y_BEGIN = 100;
 Y_ODSTUP = 10; // Vzdalenost radku osnovy
 pC = 128;
 pD = 123;
 pE = 119;
 pF = 114;
 pG = 110;
 pA = 104;
 pH = 98;
 ppc = 94;
 ppd = 89;
 ppe = 83;
 ppf = 80;
 ppg = 75;
 ppa = 72;
 pph = 67;
var
  win: Twin;
  posuv: Integer = 0; // Kterou cast osnovy vykreslit

implementation
uses uvars, ufile;
{$R *.dfm}
 { Popis:
  Po naten souboru program te jednotliv dky a ukld extrahovanou vku a
  dlku kad noty do pole Zaznam. Vka je uloena jako vzdlenost od hornho okraje
  PaintBoxu Notes, aby byla k dispozici tato hodnota bez dalho pepotvn.
  --
  Program zobraz piblin 20 not, zane vdy zatkem taktu. Nelze posouvat pohled
  po jednotliv not, jen po taktu, aby lo lpe pepotat umstn taktovch ar.
  Pi posouvn pohledu je nejprve zjitn poet not prvnho taktu, aby se zjistilo,
  o kolik not je teba posunout.
 }

{*********************************** VYKRESLENI NOT }
procedure Twin.NotesPaint(Sender: TObject);
var r: Integer; // Prv vykreslovan dka notov osnovy
    ni: Integer; // Index, podle ktereho se vykresluji noty
                 // maximalne 20 not
    xdelka: Double; // delka prave vykreslovane noty
    xvyska: Integer; // vyska prave vykreslovane noty
    xkriz: Boolean; // Ma nota kriz?
    xi: Integer; // Vzdalenost noty od leve hrany osnovy
    TECKA_ODSTUP: Integer;
    takt_hodnota: Double; // Do teto promenne se uklada delka not v taktu,
                           // jakmile se bude rovnat dobm zaznamu, vykresli se taktova cara
begin
// Vykresleni obdelniku
win.Notes.Canvas.FillRect(win.Notes.ClientRect);

// Vykreslen osnovy
for r := 0 to 4 do
begin
 win.Notes.Canvas.MoveTo(X_BEGIN, Y_BEGIN + r*Y_ODSTUP);
 win.Notes.Canvas.LineTo(780, Y_BEGIN + r*Y_ODSTUP);
end;
// Vykresleni klice a dob
 win.Notes.Canvas.Draw(30, 100, Klic);
 win.Notes.Canvas.Draw(70, 110, DobyBitmap);
//******************************************************** Vykresleni not
 xi := 0; takt_hodnota := 0; varNOT_VYKRESLENYCH := 0;
 if varKRESLIT_OD_NOTY < 0 then begin varKRESLIT_OD_NOTY := 0; Win.MaskEdit.Text := '1'; end;
 for ni := varKRESLIT_OD_NOTY to 24 + varKRESLIT_OD_NOTY do
 begin
  if (ni > (19 + varKRESLIT_OD_NOTY)) and (takt_hodnota = 0) then continue;
  if Zaznam[ni] <> nil then
  begin
  // Urceni obrazku podle delky
  xdelka := Zaznam[ni].delka;
  xkriz := Zaznam[ni].kriz;
  xvyska := Zaznam[ni].vyska;

  NotaUrcena := 0;

 // Podminky pro notu celou (pokud to neni pomlka)
 if xvyska <> 10000 then begin
  if (xdelka = 4) and (xkriz = true) then begin NotaUrcena := 7; xvyska := xvyska + 11; end;
  if (xdelka = 4) and (xkriz = false) then begin NotaUrcena := 6; xvyska := xvyska + 16; end;
 end;

 if xvyska > 97 then
 begin
  // Podminky pro notu osminovou dole
  if (xdelka = 0.5) and (xkriz = true) then NotaUrcena := 3;
  if (xdelka = 0.5) and (xkriz = false) then NotaUrcena := 2;
  // Podminky pro notu ctvrtovou dole
  if ((xdelka = 1) or (xdelka = 1.5)) and (xkriz = true) then NotaUrcena := 1;
  if ((xdelka = 1) or (xdelka = 1.5)) and (xkriz = false) then NotaUrcena := 0;
  // Podminky pro notu pulovou dole
  if ((xdelka = 2) or (xdelka = 3)) and (xkriz = true) then NotaUrcena := 5;
  if ((xdelka = 2) or (xdelka = 3)) and (xkriz = false) then NotaUrcena := 4;
  // Podminky pro pomlku
  if (xvyska = 10000) then
  begin
   if xdelka = 0.5 then NotaUrcena := 14;
   if xdelka = 1 then NotaUrcena := 15;
   if xdelka = 1.5 then NotaUrcena := 15;
   if xdelka = 2 then NotaUrcena := 16;
   if xdelka = 3 then NotaUrcena := 16;
   if xdelka = 4 then NotaUrcena := 17;
   xvyska := pG + 5;
   if (xdelka = 2) or (xdelka = 3) then xvyska := xvyska + 1;
   if xdelka = 4 then xvyska := xvyska + 5;
  end
 end
 else
 begin
  // Podminky pro notu osminovou nahore
  if (xdelka = 0.5) and (xkriz = true) then NotaUrcena := 11;
  if (xdelka = 0.5) and (xkriz = false) then NotaUrcena := 10;
  // Podminky pro notu ctvrtovou nahore
  if ((xdelka = 1) or (xdelka = 1.5)) and (xkriz = true) then NotaUrcena := 9;
  if ((xdelka = 1) or (xdelka = 1.5)) and (xkriz = false) then NotaUrcena := 8;
  // Podminky pro notu pulovou nahore
  if ((xdelka = 2) or (xdelka = 3)) and (xkriz = true) then NotaUrcena := 13;
  if ((xdelka = 2) or (xdelka = 3)) and (xkriz = false) then NotaUrcena := 12;
  if xdelka <> 4 then xvyska := xvyska + 18;
 end;


  // Samotne vykresleni
  win.Notes.Canvas.Draw(100 + xi*30, xvyska, Noty[NotaUrcena]);
  // Vykresleni pomocne linky
  if xvyska = pC then
  begin
   win.Notes.Canvas.MoveTo(96 + xi*30, 150);
   win.Notes.Canvas.LineTo(112 +xi*30, 150);
  end;



  // Vykresleni tecky za notou
  if (xdelka = 1.5) or (xdelka = 3) then  begin
  // Urceni tecky za notou podle toho, zda je to pomlka ci ne
  if NotaUrcena > 13 then
  begin
  if NotaUrcena = 15 then TECKA_ODSTUP := 6 else TECKA_ODSTUP := 0;
  end else TECKA_ODSTUP := 15;

  win.Notes.Canvas.Rectangle(113 + xi*30, xvyska + TECKA_ODSTUP, 115 + xi * 30, xvyska + TECKA_ODSTUP + 2);
  end;


  // ******** Taktova cara
  takt_hodnota := takt_hodnota + xdelka;
  if takt_hodnota = varDOBY then
  begin
   win.Notes.Canvas.MoveTo(120 +xi*30, Y_BEGIN);
   win.Notes.Canvas.LineTo(120 + xi*30, Y_BEGIN + Y_ODSTUP * 4);
   takt_hodnota := 0;
  end;
  Inc(xi);
  varNOT_VYKRESLENYCH := varNOT_VYKRESLENYCH + 1;
  end;
 end;
end;

{*********************************** SPUSTENI PROGRAMU }
procedure Twin.FormCreate(Sender: TObject);
var n: Integer;
begin

// Inicializace klice a taktu
Klic := TBitmap.Create;
Klic.LoadFromFile('.\obraz\klic.bmp');
Klic.TransparentColor := clWhite;
Klic.Transparent := true;

Takt34 := TBitmap.Create;
Takt34.LoadFromFile('.\obraz\takt_3.bmp');
Takt34.TransparentColor := clWhite;
Takt34.Transparent := true;

Takt44 := TBitmap.Create;
Takt44.LoadFromFile('.\obraz\takt_4.bmp');
Takt44.TransparentColor := clWhite;
Takt44.Transparent := true;

Takt54 := TBitmap.Create;
Takt54.LoadFromFile('.\obraz\takt_5.bmp');
Takt54.TransparentColor := clWhite;
Takt54.Transparent := true;

DobyBitmap := TBitmap.Create;
DobyBitmap.TransparentColor := clWhite;
DobyBitmap.Transparent := true;
DobyBitmap := Takt44;

//NotaUrcenaIMG := TBitmap.Create;
//NotaUrcenaIMG.TransparentColor := clWhite;
//NotaUrcenaIMG.Transparent := true;


// Inicializace bitmap
for n := 0 to 17 do begin
 Noty[n] := TBitmap.Create;
 Noty[n].TransparentColor := clWhite;
 Noty[n].Transparent := true;
end;
Noty[0].LoadFromFile('.\obraz\nota_nahoru_1.bmp');        // Nota ctvrtova nahoru
Noty[1].LoadFromFile('.\obraz\nota_krizek_nahoru_1.bmp'); // kriz Nota ctvrtova nahoru
Noty[2].LoadFromFile('.\obraz\nota_nahoru_0.bmp');        // Nota osminova nahoru
Noty[3].LoadFromFile('.\obraz\nota_krizek_nahoru_0.bmp'); // kriz Nota osminova nahoru
Noty[4].LoadFromFile('.\obraz\nota_nahoru_2.bmp');        // Nota pulova nahoru
Noty[5].LoadFromFile('.\obraz\nota_krizek_nahoru_2.bmp'); // kriz Nota pulova nahoru

Noty[6].LoadFromFile('.\obraz\nota_4.bmp');               // Nota cela
Noty[7].LoadFromFile('.\obraz\nota_krizek_4.bmp');        // kriz Nota cela

Noty[8].LoadFromFile('.\obraz\nota_dolu_1.bmp');          // Nota ctvrtova dolu
Noty[9].LoadFromFile('.\obraz\nota_krizek_dolu_1.bmp');   // kriz Nota ctvrtova dolu
Noty[10].LoadFromFile('.\obraz\nota_dolu_0.bmp');          // Nota osminova dolu
Noty[11].LoadFromFile('.\obraz\nota_krizek_dolu_0.bmp');   // kriz Nota osminova dolu
Noty[12].LoadFromFile('.\obraz\nota_dolu_2.bmp');          // Nota pulova dolu
Noty[13].LoadFromFile('.\obraz\nota_krizek_dolu_2.bmp');   // kriz Nota pulova dolu

Noty[14].LoadFromFile('.\obraz\pomlka_0.bmp');   // pomlka
Noty[15].LoadFromFile('.\obraz\pomlka_1.bmp');   // pomlka
Noty[16].LoadFromFile('.\obraz\pomlka_2.bmp');   // pomlka
Noty[17].LoadFromFile('.\obraz\pomlka_4.bmp');   // pomlka

end;


{*********************************** NACTENI SOUBORU }
procedure Twin.bLoadClick(Sender: TObject);
var i: Integer; // Mazac taktu, zaznamu
begin
//******Nacteni
for i:=0 to 1000 do Takty[i] := 0;
for i:=0 to 10000 do if Zaznam[i] <> nil then begin Zaznam[i].vyska := 10001; Zaznam[i].delka :=0; Zaznam[i].kriz := false; end;
ZaznamDelka := 0;
 if win.OpenD.Execute = true
 then
 begin
  AnalyzujVstup(win.OpenD.FileName);
 end;
varKRESLIT_OD_NOTY := 0;
win.MaskEdit.Text := '1';
NyniUkazujiOdTaktu := 0;

win.NotesPaint(win.Notes);
end;



procedure Twin.bRightClick(Sender: TObject);
var ni: Integer;
    pocetnot: Integer;
    hodnotataktu: Double;
begin
 pocetnot := 0; hodnotataktu := 0;
 // Pro posun o takt se mus zjistit, o kolik not se to m vlastn posunout
 // To se zjist potnm dlek not
 for ni := varKRESLIT_OD_NOTY  to varKRESLIT_OD_NOTY + 10 do begin
  if Zaznam[ni] = nil then break;
  Inc(pocetnot);
  hodnotataktu := hodnotataktu + Zaznam[ni].delka;
  if hodnotataktu >= varDOBY then break;
 end;
 // Nyni posunout
 varKRESLIT_OD_NOTY := varKRESLIT_OD_NOTY + pocetnot;
 Win.MaskEdit.Text := IntToStr(varKRESLIT_OD_NOTY);
 Win.NotesPaint(Win.Notes);
 Takty[NyniUkazujiOdTaktu] := varKRESLIT_OD_NOTY;
 Inc(NyniUkazujiOdTaktu);

end;

procedure Twin.bLeftClick(Sender: TObject);
begin
 Dec(NyniUkazujiOdTaktu);
 varKRESLIT_OD_NOTY := Takty[NyniUkazujiOdTaktu - 1];
 Win.MaskEdit.Text := IntToStr(varKRESLIT_OD_NOTY);
 Win.NotesPaint(Win.Notes);
end;

procedure Twin.bSaveClick(Sender: TObject);
begin
if win.SaveDialog1.Execute
then
 UlozitZaznam(win.SaveDialog1.FileName);
end;

end.
